/**
 * \file
 *
 * \brief Empty user application template
 *
 */

/**
 * \mainpage User Application template doxygen documentation
 *
 * \par Empty user application template
 *
 * Bare minimum empty user application template
 *
 * \par Content
 *
 * -# Include the ASF header files (through asf.h)
 * -# Minimal main function that starts with a call to system_init()
 * -# "Insert application code here" comment
 *
 */

/*
 * Include header files for all drivers that have been imported from
 * Atmel Software Framework (ASF).
 */
/*
 * Support and FAQ: visit <a href="http://www.atmel.com/design-support/">Atmel Support</a>
 */
#include <asf.h>




#define BUTTON_PIN		PIN_PA13
#define LED0_PIN		PIN_PB30
#define LED0_ACTIVE		false
#define LED0_INACTIVE	!LED0_ACTIVE

#define LED_ON			port_pin_set_output_level(LED0_PIN, LED0_ACTIVE);
#define LED_OFF			port_pin_set_output_level(LED0_PIN, LED0_INACTIVE);
#define LED_TOGGLE		port_pin_toggle_output_level(LED0_PIN);	

/** Handler for the device SysTick module, called when the SysTick counter
 *  reaches the set period.
 *
 *  \note As this is a raw device interrupt, the function name is significant
 *        and must not be altered to ensure it is hooked into the device's
 *        vector table.
 */


void SysTick_Handler(void)
{
	
	static uint16_t delaycount = 0;

	if (delaycount < 250)
	{
		delaycount++;
	} else {
		delaycount = 0;
		LED_TOGGLE		
	}
	
}



static void configure_systick_handler(void)
{
	SysTick->CTRL = 0;
	SysTick->LOAD = 8000; //48000; // 1ms Event (1ms/(1/48Mhz))   
	SysTick->VAL  = 0;
	SysTick->CTRL = SysTick_CTRL_CLKSOURCE_Msk | SysTick_CTRL_TICKINT_Msk | SysTick_CTRL_ENABLE_Msk;
}






int main (void)
{
	
				
	// Initialization Section			
	irq_initialize_vectors();
	cpu_irq_enable();	
	system_init();
		
	// LED
	struct port_config config_port_pin;
	port_get_config_defaults(&config_port_pin);
	config_port_pin.direction = PORT_PIN_DIR_OUTPUT;
	port_pin_set_config(LED0_PIN, &config_port_pin);
	
	// BUTTON
	port_get_config_defaults(&config_port_pin);	
	config_port_pin.direction = PORT_PIN_DIR_INPUT;
	config_port_pin.input_pull = PORT_PIN_PULL_UP;
	port_pin_set_config(BUTTON_PIN, &config_port_pin);
		
	configure_systick_handler();

LED_ON
	while (1)
	{
		
		// main loop of application code
		
		if (!port_pin_get_input_level(BUTTON_PIN)) {
			/* Button is pressed */
			LED_ON
		}
		
	}

}


